# Written by Bram Cohen
# see LICENSE.txt for license information
# Updated and modified for ABC_OKC : Old King Cole

from time import clock


class Measure:
    def __init__(self, window, start = None, last = None, rate = 0.0):
        self.window = window
        if start is None:
            self.start = clock()
        else:
            self.start = start
        if last is None:
            self.last = clock()
        else:
            self.last = last
        self.rate = rate
        self.total = 0L

    def update_rate(self, amount):
        now = clock()
        window = min(self.window, now - self.start)
        self.rate = (self.rate * max(self.last - now + window, 0) + amount) / window
        self.total += amount
        self.last = now
        return self.rate

    def get_rate(self):
        now = clock()
        window = min(self.window, now - self.start)
        return self.rate * max(self.last - now + window, 0) / window

    def get_total(self):
        return self.total

    def setWindow(self, window):
        self.window = window

    def reset(self):
        self.rate = 0.0
