##############################################################################
# Module : exitdlg.py
# Author : Old King Cole
# Date   : 07/13/2005
#
# Description : Exit ABC_OKC dialog
#
##############################################################################
import wx


class ExitDialog(wx.Dialog):
    def __init__(self, parent, title):
        pre = wx.PreDialog()
        pre.Create(parent, -1, title, wx.DefaultPosition, wx.DefaultSize, wx.CAPTION | wx.STAY_ON_TOP)
        self.this = pre.this

        self.p = wx.Panel(self, -1)
        outerbox = wx.BoxSizer(wx.VERTICAL)

        box = wx.StaticBoxSizer(wx.StaticBox(self.p, -1, ''), wx.HORIZONTAL)

        self.text = wx.StaticText(self.p, -1, '', size = (300, -1), style = wx.ALIGN_LEFT | wx.ST_NO_AUTORESIZE)

        box.Add(self.text, 1, wx.ALIGN_CENTER_VERTICAL)

        outerbox.Add(box, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.TOP, -6)

        self.p.SetAutoLayout(True)
        self.p.SetSizer(outerbox)
        self.p.Fit()
        self.SetClientSize(self.p.GetSize())
        self.Centre(wx.CENTRE_ON_SCREEN)

        self.Bind(wx.EVT_MOVE, self.moveHandler)
        # Filter out alt+F4
        self.Bind(wx.EVT_CLOSE, self.closeHandler)

    def setText(self, text):
        self.text.SetLabel(text)
        self.p.Refresh()
        self.p.Update()

    def moveHandler(self, event):
        pass

    def closeHandler(self, event):
        pass
